with Ada.Text_IO, Globals, Strings, Ints, Flts, Reps, Reps.Balls;
use Ada.Text_IO, Globals, Strings, Ints, Flts, Reps.Balls;
with Matrices, Vectors, ScalVectors, Polynoms, Taylors1, Taylors1.Skews, Taylors1.Skews.Pairs;

pragma Elaborate_All (Ada.Text_IO,Globals,Strings,Ints,Flts);
pragma Elaborate_All (Matrices,Vectors,ScalVectors,Polynoms,Taylors1.Skews.Pairs);

procedure Check_Fixpt is

  subtype Scalar is Ball;

  PDeg: constant Positive := GetArg;  --- 600
  NT: constant Positive := GetArg;
  NDigits: constant Positive := 1024;

  Mat_PackSize: constant Positive := 32;
  Contr_PackSize: constant Positive := 128;

  RhoF: constant Radius := Three;
  RhoG: constant Radius := Two;

  Dummy: constant Positive := Reps.Set_Precision(NDigits);

  package SM is new Matrices (Scalar => Scalar);
  package SV is new Vectors (Component => Scalar);
  package SP is new Polynoms (Scalar => Scalar, SV => SV);
  package ST is new Taylors1 (PDeg => PDeg, Scalar => Scalar, SM => SM, SV => SV, SP => SP);
  package SSV is new ScalVectors (Scalar => Scalar, SM => SM, SV => SV);
  package STC is new ST.Skews;
  package STCP is new STC.Pairs (RhoF => RhoF, RhoG => RhoG, Mat_PackSize => Mat_PackSize, SSV => SSV);
  use SM,ST,STC,STCP;

  P: Skew2;
  M: QC_Matrix;

begin

  Verbosity := 2;
  NTasks := NT;
  Show_Param;

  Read(Input_Dir & "approx-Fix",P);
  SetRho(RhoP,P,False);
  NumTrunc(P);
  Normalize(P,True);
  Read(Input_Dir & ContrMat_Name,M);
  NumTrunc(M);

  ContrFix(M,Contr_PackSize,P);
  Write(Output_Dir & Fix_Name,P);

end Check_Fixpt;
