
package body Golden is

  function "-"(N: GNum) return GNum is
  begin
    return (-N.I,-N.G);
  end "-";

  function "+"(I: Integer; N: GNum) return GNum is
  begin
    return (I+N.I,N.G);
  end "+";

  function "+"(N: GNum; I: Integer) return GNum is
  begin
    return (N.I+I,N.G);
  end "+";

  function "+"(N1,N2: GNum) return GNum is
  begin
    return (N1.I+N2.I,N1.G+N2.G);
  end "+";

  function "-"(I: Integer; N: GNum) return GNum is
  begin
    return (I-N.I,-N.G);
  end "-";

  function "-"(N: GNum; I: Integer) return GNum is
  begin
    return (N.I-I,N.G);
  end "-";

  function "-"(N1,N2: GNum) return GNum is
  begin
    return (N1.I-N2.I,N1.G-N2.G);
  end "-";

  function "*"(I: Integer; N: GNum) return GNum is
  begin
    return (I*N.I,I*N.G);
  end "*";

  function "*"(N: GNum; I: Integer) return GNum is
  begin
    return (N.I*I,N.G*I);
  end "*";

  function "*"(N1,N2: GNum) return GNum is
    --- InvGold**2=1-InvGold
    GG: constant Integer := N1.G*N2.G;
  begin
    return (N1.I*N2.I+GG,N1.I*N2.G+N1.G*N2.I-GG);
  end "*";

  function "**"(N: GNum; I: Natural) return GNum is
  begin
    case I is
      when 0 => return (1,0);
      when 1 => return N;
      when 2 => return N*N;
      when 3 => return N*N*N;
      when others => null;
    end case;
    declare
      J: Natural := I/2;
      Fac,Prod: GNum;
    begin
      if (I mod 2)=0 then
        Prod := (1,0);
      else
        Prod := N;
      end if;
      Fac := N;
      while J>0 loop
        Fac := Fac*Fac;
        if (J mod 2)=1 then
          Prod := Fac*Prod;
        end if;
        J := J/2;
      end loop;
      return Prod;
    end;
  end "**";

end Golden;
