
package Golden is --- simple, for Z[golden mean]

  type GNum is
    record
      I: Integer; -- coeff of 1
      G: Integer; -- coeff of Inv_Gold
    end record;

  GZero:    constant GNum := (0,0);
  GOne:     constant GNum := (1,0);
  Inv_Gold: constant GNum := (0,1); -- inverse golden mean
  Gold:     constant GNum := (1,1); -- golden mean

  function "-"(N: GNum) return GNum;
  function "+"(I: Integer; N: GNum) return GNum;
  function "+"(N: GNum; I: Integer) return GNum;
  function "+"(N1,N2: GNum) return GNum;
  function "-"(I: Integer; N: GNum) return GNum;
  function "-"(N: GNum; I: Integer) return GNum;
  function "-"(N1,N2: GNum) return GNum;
  function "*"(I: Integer; N: GNum) return GNum;
  function "*"(N: GNum; I: Integer) return GNum;
  function "*"(N1,N2: GNum) return GNum;
  function "**"(N: GNum; I: Natural) return GNum;

end Golden;
