
package body ScalGolden is

  procedure ContFrac(N: in Natural; P,Q: out Natural; Kappa: in Positive := 1) is
    R: Integer;
  begin
    P := 0;
    Q := 1;
    for I in 1 .. N loop
      R := Kappa*Q+P;
      P := Q;
      Q := R;
    end loop;
  end ContFrac;

  procedure ContFrac(N: in Natural; S: in out Scalar; Kappa: in Positive := 1) is
    P,Q: Natural;
  begin
    ContFrac(N,P,Q,Kappa);
    Assign(P,S);
    Div(Flt(Q),S);
  end ContFrac;

  function ContFrac(N: Natural; Kappa: Positive := 1) return Scalar is
    S: Scalar;
  begin
    ContFrac(N,S,Kappa);
    return S;
  end ContFrac;

  procedure InvGold(S: in out Scalar) is
  begin
    Sqrt(SFive,S);
    Sub(SOne,S);
    Mult(SHalf,S);
  end InvGold;

  function InvGold return Scalar is
    S: Scalar;
  begin
    InvGold(S);
    return S;
  end InvGold;

  procedure Assign(I,G: in Integer; S: in out Scalar) is
  begin
    if G=0 then
      Assign(I,S);
    elsif I=0 then
      Prod(Flt(G),SInvGold,S);
    elsif G>0 and then I>0 then
      Prod(Flt(G),SInvGold,S);
      Add(I,S);
    elsif G<0 and then I<0 then
      Assign(-I,-G,S);
      Neg(S);
    else --- I+G*InvGold=I*(1-InvGold)+(I+G)*InvGold=[I*InvGold+(I+G)]*InvGold
      Assign(I+G,I,S);
      Mult(SInvGold,S);
    end if;
  end Assign;

  procedure Assign(N: in GNum; S: in out Scalar) is
  begin
    Assign(N.I,N.G,S);
  end Assign;

  function Scal(N: GNum) return Scalar is
    S: Scalar;
  begin
    Assign(N.I,N.G,S);
    return S;
  end Scal;

begin

  InvGold(SInvGold);

end ScalGolden;
