with Golden, Flts;
use Golden, Flts;

pragma Elaborate_All (Golden,Flts);

generic

  type Scalar is private;

  with procedure Neg(S: in out Scalar) is <>;
  with procedure Sub(S1: in Scalar; S2: in out Scalar) is <>;
  with procedure Mult(S1: in Scalar; S2: in out Scalar) is <>;
  with procedure Sqrt(S1: in Scalar; S2: in out Scalar) is <>;

  with procedure Assign(I: in Integer; S: in out Scalar) is <>;
  with procedure Add(I: in Integer; S: in out Scalar) is <>;

  with function Scal(R: Flt) return Scalar is <>;
  with procedure Div(R: in Flt; S: in out Scalar) is <>;
  with procedure Prod(R: in Flt; S1: in Scalar; S2: in out Scalar) is <>;

package ScalGolden is --- some ope related to the golden mean

  pragma Elaborate_Body;

  procedure ContFrac(N: in Natural; P,Q: out Natural; Kappa: in Positive := 1);
  procedure ContFrac(N: in Natural; S: in out Scalar; Kappa: in Positive := 1);
  function ContFrac(N: Natural; Kappa: Positive := 1) return Scalar;

  procedure InvGold(S: in out Scalar);
  function InvGold return Scalar;
  procedure Assign(N: in GNum; S: in out Scalar);
  function Scal(N: GNum) return Scalar;

private

  SOne: constant Scalar := Scal(One);
  SHalf: constant Scalar := Scal(Half);
  SFive: constant Scalar := Scal(Five);
  SInvGold: Scalar;

end ScalGolden;
